; File: Input1.asm
;
; 
    include \masm32\include\masm32rt.inc

    Include	      \masm32\fpulib\fpu.inc
    IncludeLib	\masm32\fpulib\fpu.lib

InputABC        proto :DWORD,:DWORD,:DWORD
; 
.data
; ##############################################################################################
_NumberA        REAL10 ?
_NumberB        REAL10 ?
_NumberC        REAL10 ?
;------------------------------------
_captionA       db "Input a", 0
_captionB       db "Input b", 0
_captionC       db "Input c", 0
;------------------------------------
_StringA        db 60 dup (?)
_StringB        db 60 dup (?)
_StringC        db 60 dup (?)
;------------------------------------
.data?
_hInstance      dd ?
_OutBuffer      db 180 dup (?)          ; buffer to handle the equation
; 
.code
start:
            invoke  GetModuleHandle, 0              
            mov     _hInstance, eax            ;return value in eax=handle of program

            call    main
            invoke  ExitProcess, 0   
;...................................................
main        proc

            invoke  InputABC, addr _NumberA, addr _captionA, addr _StringA
            jc      _Emain
            ;
            cmp     eax, 0
            je      _Emain
            ;
            invoke  InputABC, addr _NumberB, addr _captionB, addr _StringB
            jc      _Emain
            ;
            invoke  InputABC, addr _NumberC, addr _captionC, addr _StringC 
            jc      _Emain   
                                
            call    OutputABC
            print   offset _OutBuffer
            print   chr$(13, 10)                        
            inkey
            ret
            ;
            ; Input error
            ; ----------
_Emain:     print   chr$("Error", "Error")
            ;            
            ; Stop and wait for a key
            ; -----------------------
            inkey
            ret
main        endp 
; ##########################################################################################
; Action:
;           Gets the alphanumeric string that stands for an integer number
;           Put the string into a buffer pointed by pBuf (is a null-terminated string)
;           The string begins with the sign + or -;
;           Converts that string to an integer and put the result into the variable
;           pointed by pABC
;
; Output:
;           clc:    accepted
;
;           stc:    rejected: input error 
;                             or more than 10 digits
;
InputABC        proc    pABC:DWORD, pCaption:DWORD, pBuf:DWORD
                LOCAL   Buffer[60]:BYTE
                ;
                push    esi
                push    edi
                ;
                lea     esi, Buffer                
                invoke  GetTextInput, NULL, _hInstance, NULL, pCaption,
                                      NULL, esi
                cmp     eax, 1
                je      _eInputABC                      ; exit                             
                ; 
                mov     edi, pBuf                                                              
                xor     ecx, ecx        ; number of digits + 1 sign + 1
                ;
                xor     edx, edx
_iInputABC:     movzx   eax, byte ptr [esi + edx]
                inc     edx
                ;
                cmp     al, 0
                je      _aInputABC 
                ;                
                cmp     al, 20h
                je      _iInputABC              ; space
                ;                
                cmp     al, 9h
                je      _iInputABC              ; tab
                ;
                cmp     al, "-"
                je     _nInputABC0
                ;                             
                cmp     al, "+"
                je     _nInputABC0
                ;
                cmp     al, "."
                je     _nInputABC0
                ;                
                cmp     al, "0"
                jb      _eInputABC
                ;
                cmp     al, "9"
                ja      _eInputABC
                ;
                mov     byte ptr [edi + ecx], "+"           ; begin with +
                inc     ecx
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
_nInputABC0:    mov     byte ptr [edi + ecx], al
                inc     ecx
                ;
_nInputABC:     movzx   eax, byte ptr [esi + edx]
                inc     edx
                ;
                cmp     al, 0
                je      _aInputABC 
                ;                
                cmp     al, 20h
                je      _nInputABC
                ;                
                cmp     al, 9h
                je      _nInputABC                                
                ;
                cmp     al, "."
                je     _nInputABC0
                ;                                
                cmp     al, "0"
                jb      _eInputABC
                ;
                cmp     al, "9"
                jbe      _nInputABC0                                
                ja      _eInputABC
                ;     
_aInputABC:     cmp     ecx, 0
                je      _eInputABC                  ; reject
                ;
                cmp     ecx, 12
                ja      _eInputABC                  ; more than 10 digits
                ;
                ; convert
                ; -------  
                mov     byte ptr [edi + ecx], 0     ; end with 0
                ;
                mov     edx, pABC                
                invoke  FpuAtoFL, edi, edx, DEST_MEM
                or      eax, eax
                jz      _eInputABC                  ; error
                ;
                clc
                pop     edi
                pop     esi
                ret
                ;
_eInputABC:     stc
                pop     edi
                pop     esi
                ret
InputABC        endp
; 
OutputABC       proc
                push    edi
                ;
                cld
                mov     edi, offset _OutBuffer
                mov     edx, offset _StringA
                ;
@@:             movzx   eax, byte ptr [edx]
                inc     edx
                cmp     al, 0
                je      @F
                ;
                stosb
                jne     @B
                
@@:             mov     eax, "2^X " 
                stosd
                ;
                mov     al, " "
                stosb
                ;
                mov     edx, offset _StringB
                ;
@@:             movzx   eax, byte ptr [edx]
                inc     edx
                cmp     al, 0
                je      @F
                ;
                stosb
                jne     @B
                
@@:             mov     eax, "  X " 
                stosd
                ;
                mov     edx, offset _StringC
                ;
@@:             movzx   eax, byte ptr [edx]
                inc     edx
                cmp     al, 0
                je      @F
                ;
                stosb
                jmp     @B
                
@@:             mov     eax, " 0= " 
                stosd
                mov     byte ptr [edi], 0       ; end with 0                             
                ;
                pop     edi
                ret
OutputABC       endp
; 
end   start

















